#include "boardTable.h"
#include "fileIO.h"

void BoardTable::makeWinLose(){
  // 
  for(size_t i=0;i<allBoard.size();i++){
    Board state;
    state.init(allBoard[i]);
    if(state.canWin()){
      winOrLose[i]=100; // win
    }
    else
      winOrLose[i]=0; // unknown
  }
  for(int nmoves=1;;nmoves++){
    int changed=0;
    for(size_t i=0; i< winOrLose.size(); i++){
      if(winOrLose[i]!=0) continue;
      int minval=100;
      for(size_t j=0;j<allNexts[i].size();j++)
	minval=min(minval,static_cast<int>(winOrLose[allNexts[i][j]]));
      if(minval!=0){
	if(minval>0)
	  winOrLose[i]= -minval+1;
	else
	  winOrLose[i]= -minval-1;
	changed++;
      }
    }
    //    cerr << "nmoves=" << nmoves << ",changed=" << changed << endl;
    if(changed==0)break;
  }
}
void BoardTable::make(){
  hash_map<PackedBoard,int> s2iMap;
  Board initialState;
  s2i(s2iMap,initialState.packRev());
  //  int lastSize=0;
  for(size_t i=0;i<allBoard.size();i++){
    Board state;
    state.init(allBoard[i]);
#if 0
    if(lastSize!=state.nStones()){
      cerr << lastSize << " -> " << state.nStones() << " @ " << i << endl;
      lastSize=state.nStones();
    }
#endif
    vector<PackedBoard> nexts;
    if(state.nStones()<8){
      if(state.canWinByDrop())
	continue;
      state.nextDrops(nexts);
    }
    else{
      if(state.canWinByMove())
	continue;
      state.nextMoves(nexts);
    }
    for(size_t j=0;j<nexts.size();j++){
      int index=s2i(s2iMap,clearRot(nexts[j]));
      allNexts[i].push_back(index);
    }
  }
  //  cerr << "allBoard=" << allBoard.size() << endl;
  makeWinLose();
}
void BoardTable::save(char * filename){
  ofstream ofs(filename);
  putLL(ofs,allBoard.size());
  for(size_t i=0;i<allBoard.size();i++)
    putLL(ofs,allBoard[i]);
  for(size_t i=0;i<winOrLose.size();i++)
    putC(ofs,winOrLose[i]);
  for(size_t i=0;i<allNexts.size();i++){
    putI(ofs,static_cast<int>(allNexts[i].size()));
    for(size_t j=0;j<allNexts[i].size();j++)
      putI(ofs,allNexts[i][j]);
  }
}
void BoardTable::load(char * filename){
  ifstream ifs(filename);
  size_t size=static_cast<size_t>(getLL(ifs));
  //  cerr << "size=" << size << endl;
  allBoard.resize(size);
  winOrLose.resize(size);
  allNexts.resize(size);
  for(size_t i=0;i<size;i++)
    allBoard[i]=getLL(ifs);
  //  cerr << "done allBoard=" << size << endl;
  for(size_t i=0;i<size;i++)
    winOrLose[i]=getC(ifs);
  //  cerr << "done winOrLose=" << size << endl;
  //  size_t maxsize=0;
  for(size_t i=0;i<size;i++){
    size_t size1=static_cast<size_t>(getI(ifs));
    allNexts[i].resize(size1);
    for(size_t j=0;j<size1;j++)
      allNexts[i][j]=getI(ifs);
#if 0
    if(size1>maxsize){
      cerr << size1 << endl;
      showState(cerr,i);
      maxsize=size1;
    }
#endif
  }
}
