#include "color.h"
#include <sstream>
#include <cppunit/TestCase.h>
#include <cppunit/extensions/HelperMacros.h>

class ColorTest : public CppUnit::TestFixture 
{
  CPPUNIT_TEST_SUITE(ColorTest);
  CPPUNIT_TEST(testInput);
  CPPUNIT_TEST(testOutput);
  CPPUNIT_TEST(testAlt);
  CPPUNIT_TEST_SUITE_END();
 public:
  void testInput();
  void testOutput();
  void testAlt();
};

CPPUNIT_TEST_SUITE_REGISTRATION(ColorTest);

void ColorTest::testInput()
{
  {
    std::istringstream iss("+");
    Color c;
    iss >> c;
    CPPUNIT_ASSERT_EQUAL(c,RED);
  }
  {
    std::istringstream iss(".");
    Color c;
    iss >> c;
    CPPUNIT_ASSERT_EQUAL(c,EMPTY);
  }
  {
    std::istringstream iss("-");
    Color c;
    iss >> c;
    CPPUNIT_ASSERT_EQUAL(c,BLUE);
  }
}

void ColorTest::testOutput()
{
  {
    std::ostringstream oss;
    oss << RED;
    CPPUNIT_ASSERT(oss.str() == "+");
  }
  {
    std::ostringstream oss;
    oss << BLUE;
    CPPUNIT_ASSERT(oss.str() == "-");
  }
  {
    std::ostringstream oss;
    oss << EMPTY;
    CPPUNIT_ASSERT(oss.str() == ".");
  }
}

void ColorTest::testAlt()
{
  CPPUNIT_ASSERT_EQUAL(alt(RED),BLUE);
  CPPUNIT_ASSERT_EQUAL(alt(EMPTY),EMPTY);
  CPPUNIT_ASSERT_EQUAL(alt(BLUE),RED);
}
