/**
 * $B>WFM$N>/$J$$%O%C%7%e4X?t$r5a$a$k!%(B
 */
#include "boardTable.h"
#include "playTable.h"
#include <iostream>
#include <algorithm>
#include <fstream>
#include <vector>
using namespace std;


unsigned int hash2(PackedBoard packed)
{
  packed>>=7ll;
  unsigned int ret=0u;
  for(int i=0;i<25;i++){
    ret+=(static_cast<int>(packed)&0x3)*(rnds[24-i]&0x7ffff);
    packed>>=2ull;
  }
  ret&=0x7ffff;
  return static_cast<unsigned int>(ret);
}

int main()
{
  BoardTable table;
  table.load("unreachable.dat");
  size_t size=table.winOrLose.size();
#if 1
      Board b1(". . . .\n"
	       " . . .\n"
	       ". + - +\n"
	       " . . .\n"
	       ". . . .\n"
	       " . . .\n"
	       ". . . .\n");
      PackedBoard p1=clearRot(b1.packRev());

  vector<vector<PlayTable> > playBlock(0x80000);
  for(size_t i=0;i<size;i++){
    PackedBoard bestNext=makeInvalid();
    int minval=101;
	if(p1 == table.allBoard[i]){
	  Board b2;
	  b2.init(p1);
	  cerr << "i=" << i << endl;
	  cerr << "hashVal=" << hash(table.allBoard[i]) << endl;
	  cerr << "allNext.size=" << table.allNexts[i].size() << endl;
	}
    for(size_t j=0;j<table.allNexts[i].size();j++){
      int tmpval=static_cast<int>(table.winOrLose[table.allNexts[i][j]]);
	if(p1 == table.allBoard[i]){
	  Board b2;
	  b2.init(table.allBoard[table.allNexts[i][j]]);
	  cerr << i << " : tmpval=" << tmpval << endl << b2 << endl;
	}
      if(minval>tmpval){
	minval=tmpval;
	bestNext=table.allBoard[table.allNexts[i][j]];
      }
    }
    playBlock[hash(table.allBoard[i])].
      push_back(PlayTable(table.allBoard[i],
			  bestNext,
			  table.winOrLose[i]));
  }
  vector<int> counts(0x1000,0);
  ofstream ofs("playtable.dat");
  for(size_t j=0;j<0x80000;j++){
    size_t k=0;
#if 1
    Board b;
    for(;k<playBlock[j].size();k++){
#if 0
      cerr << "-----" << endl;
      b.init(playBlock[j][k].packed);
      cerr << b << endl;
      cerr << static_cast<int>(playBlock[j][k].winOrLose) << endl;
      b.init(playBlock[j][k].bestNext);
      cerr << b << endl;
#endif
      if(playBlock[j][k].packed==p1){
	cerr << "j=" << j << ",k=" << k << endl;
	Board b1;
	b1.init(playBlock[j][k].bestNext);
	cerr << b1 << ",winOrLose=" << playBlock[j][k].winOrLose << endl;
      }
      ofs << playBlock[j][k];
    }
    PlayTable pt(makeInvalid(),makeInvalid(),0);
    for(;k<PlayTableFile::maxGroupSize;k++){
      ofs << pt;
    }
#else
    counts[playBlock[j].size()]++;
#endif
  }
  for(int i=0;i<0x1000;i++)
    if(counts[i]>0)
      cerr << i << "," << counts[i] << endl;
#endif
  return 0;
}
