#ifndef _PLAY_TABLE_H
#define _PLAY_TABLE_H
#include "packedBoard.h"
#include <fstream>
#include <iosfwd>
using namespace std;

static unsigned int rnds[]={
  13544,
  232952,
  404590,
  340293,
  343180,
  61445,
  319893,
  439120,
  35675,
  247217,
  467116,
  345073,
  286692,
  179710,
  520709,
  254807,
  400285,
  38504,
  65493,
  57363,
  178083,
  384764,
  149309,
  311269,
  105882,
};
static inline unsigned int hash(PackedBoard packed)
{
  packed>>=3ll;
  unsigned int ret=0u;
  for(int i=0;i<25;i++){
    ret+=(static_cast<int>(packed)&0x3)*(rnds[i]&0x7ffff);
    packed>>=2ull;
  }
  ret&=0x7ffff;
  return static_cast<unsigned int>(ret);
}

struct PlayTable 
{
  PackedBoard packed;
  PackedBoard bestNext;
  char winOrLose;
  PlayTable(PackedBoard packed,PackedBoard bestNext,char winOrLose)
    :packed(packed),bestNext(bestNext),winOrLose(winOrLose){}
  PlayTable(){}
};
istream& operator>>(istream& is,PlayTable & pt);
ostream& operator<<(ostream& os,PlayTable const& pt);

class PlayTableFile
{
 public:
  enum {
    maxGroupSize=46,
  };
 private:
  ifstream ifs;
 public:
  PlayTableFile(const char *fileName) :ifs(fileName){}
  PlayTable find(PackedBoard const& packed);
};

#endif /* _PLAY_TABLE_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:

