#include "board.h"
#include "playTable.h"
#include <cppunit/TestCase.h>
#include <cppunit/extensions/HelperMacros.h>
#include <iostream>

class PlayTableTest : public CppUnit::TestFixture 
{
  CPPUNIT_TEST_SUITE(PlayTableTest);
  CPPUNIT_TEST(testShow);
  CPPUNIT_TEST_SUITE_END();
 public:
  void testShow();
};
CPPUNIT_TEST_SUITE_REGISTRATION(PlayTableTest);

void PlayTableTest::testShow()
{
  PlayTableFile ptf("playtable.dat");
  {
    Board b(". . . .\n"
	    " . . .\n"
	    ". + . -\n"
	    " . . .\n"
	    ". . . .\n"
	    " . . .\n"
	    ". . . .\n");
    PackedBoard packed=clearRot(b.packRev());
    PlayTable pt=ptf.find(packed);
    Board b1;
    b1.init(pt.packed);
    std::cerr << "------" << std::endl;
    std::cerr << b1 << std::endl;
    std::cerr << static_cast<int>(pt.winOrLose) << std::endl;
    if(!isInvalid(pt.bestNext)){
      b1.init(pt.bestNext);
      std::cerr << b1 << std::endl;
    }
  }
}
