/**
 * $BC1=c$J%k!<%W$N8!=P(B
 */
#include "board.h"
#include "boardTable.h"
#include <iostream>
#include <vector>
using namespace std;

void testput(Board& board,hash_map<PackedBoard,int> & s2iMap,int red, int blue,int i,int& count)
{
  if(red==0 && blue==0){
    PackedBoard packed=clearRot(board.packRev());
    hash_map<PackedBoard,int>::const_iterator it=s2iMap.find(packed);
    if(it==s2iMap.end()){
#if 0
      Board board1;
      board1.init(packed);
      std::cerr << board1 << std::endl;
#endif
      s2iMap[packed]=0;
      count++;
    }
    return;
  }
  if(i>=25) return;
  if(red>0){
    board[i]=RED;
    testput(board,s2iMap,red-1,blue,i+1,count);
    board[i]=EMPTY;
  }
  if(blue>0){
    board[i]=BLUE;
    testput(board,s2iMap,red,blue-1,i+1,count);
    board[i]=EMPTY;
  }
  testput(board,s2iMap,red,blue,i+1,count);
}

int loops[10000];
int loopCount;

void checkloop(BoardTable& boardTable,int i,vector<int>& vs)
{
  vector<int>::const_iterator it=find(vs.begin(),vs.end(),i);
  if(it!=vs.end()){
    if(i!=vs[0]) return;
    loops[vs.size()]++;
    loopCount++;
    return;
  }
  int next= -1;
  for(size_t j=0;j<boardTable.allNexts[i].size();j++){
    int k=boardTable.allNexts[i][j];
    if(boardTable.winOrLose[k]==0){
      if(next!= -1) return;
      next=k;
    }
  }
  if(next== -1) return;
  vs.push_back(i);
  checkloop(boardTable,next,vs);
}

int main()
{
  BoardTable table;
  table.load("unreachable.dat");
  for(size_t i=0;i<table.allBoard.size();i++){
    if(table.winOrLose[i]==0){
      vector<int> vs;
      checkloop(table,i,vs);
    }
  }
  cout << loopCount << endl;
  for(size_t i=0;i<1000;i++)
    if(loops[i]>0) cout << i << " & " << loops[i] << " \\\\ \\hline" << endl;
  return 0;
}
